'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.chainGuards = exports.guard = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _redirect = require('redux-auth-wrapper/history4/redirect');

var _connectedAuthWrapper = require('redux-auth-wrapper/connectedAuthWrapper');

var _connectedAuthWrapper2 = _interopRequireDefault(_connectedAuthWrapper);

var _index = require('../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var chainGuards = function chainGuards(first, second) {
    return function (DecoratedComponent) {
        return first(second(DecoratedComponent));
    };
};
var guard = function guard(_ref) {
    var expression = _ref.expression,
        redirectPath = _ref.redirectPath,
        props = _objectWithoutProperties(_ref, ['expression', 'redirectPath']);

    var authenticatedSelector = function authenticatedSelector(state, _ref2) {
        var accessDecisionManager = _ref2.accessDecisionManager;
        return accessDecisionManager.decide(expression);
    };
    var authWrapper = void 0;
    if (redirectPath) {
        authWrapper = (0, _redirect.connectedReduxRedirect)(_extends({
            redirectPath: redirectPath,
            authenticatedSelector: authenticatedSelector
        }, props));
    } else {
        authWrapper = (0, _connectedAuthWrapper2.default)(_extends({
            authenticatedSelector: authenticatedSelector
        }, props));
    }

    function wrapGuard(DecoratedComponent) {
        return (0, _index.authConnect)(authWrapper(DecoratedComponent));
    }

    return wrapGuard;
};
exports.default = guard;
exports.guard = guard;
exports.chainGuards = chainGuards;